# -*- Mode: rpm-spec -*-
#
# (c) Mandriva
#
# if you try to understand kernel numbering, read docs/kernel_naming

# sublevel ist die gngige 3. Stelle der Kernelversion
# ich werde testen, ob hier eine Doppelstelle "12.1" angenommen wird
# alternativ ist eine weitere Variable z. Bsp. "stable_followup" einzufgen und an relevanten Stellen einzuarbeiten.
%define sublevel 12
# zu nutzen bei neuen vierstelligen Kerneln
# Ich baue den erstmal in die Paketenamen ein, spter muss der auch in die Sourcen rein!
# Bislang ist einer der patches "AB01_2.6.12.1.patch" zum Upgrade da. Das knnen wir ndern
# und mssen das auch, wenn wir die Patches gar nicht einspielen wollen.
#
# Alternativ knnten wir auch mit 3 Stellen arbeiten und in Source 101 den Kernelpatch fr die 4. Stelle einbauen
%define second_sublevel 4

%define mdkrelease 8

# use_patch 0 - final release
# use patch 1 - patche von final auf release candidate
%define use_patch 1

# patchlevel muss auf 1 gesetzt werden und kann dann fortlaufend erhht werden,
# wenn nach Abarbeiten der von Mandriva vorgesehenen
# Patches noch eigene angewendet werden sollen. Nutze dafr Source ab 101
#define patchlevel 0

# This is only to make life easier for people that creates derivated kernels
# a.k.a name it kernel-tmb :)
# %define kname kernel-selfpatched
%define kname kernel-vanilla

# You should not have to change any other name/patch/version number
%define major 6

# When we are using a pre/rc patch, the tarball is a sublevel -1
%if %use_patch
#%define tar_version 2.%{major}.%(expr %{sublevel} - 1)
#%define patchversion %{use_patch}q%{mdkrelease}
#%define realrelease 0.%{use_patch}.%{mdkrelease}%{?patchlevel:.%{patchlevel}}dok
#%else
%define tar_version 2.%{major}.%{sublevel}
%define patchversion q%{mdkrelease}
%define realrelease %{mdkrelease}%{?patchlevel:.%{patchlevel}}dok
%endif

# never touch the folowing two fields
%define rpmversion 1
%define rpmrelease 205.mud
# zur Verwendung muss erst eine eigene Config angepasst werden.
#%define realversion 2.%{major}.%{sublevel}
%define realversion 2.%{major}.%{sublevel}.%{second_sublevel}

# hier mssen wir ansetzen um einen vernnftigen Namen zu bekommen
#%define mdkversion %{realversion}.%{realrelease}
%define mdkversion %{realversion}

%define patches_ver 2.%{major}.%{sublevel}-%{patchversion}

# having different top level names for packges means
# that you have to remove them by hard :(
%define top_dir_name %{kname}-2.%{major}

%define build_dir ${RPM_BUILD_DIR}/%top_dir_name
%define src_dir %{build_dir}/linux-%tar_version
%define KVERREL %{realversion}-%{realrelease}

# this is the config that contains all the drivers for the hardware/
# things that I use (Juan Quintela).
%define build_minimal 0

%define build_kheaders 0
%define build_debug 0
%define build_doc 1
%define build_source 1

%define build_up 1

# End of user definitions
%{?_without_up: %global build_up 0}
%{?_without_debug: %global build_debug 0}
%{?_without_doc: %global build_doc 0}
%{?_without_source: %global build_source 0}

%{?_with_up: %global build_up 1}
%{?_with_debug: %global build_debug 1}
%{?_with_doc: %global build_doc 1}
%{?_with_source: %global build_source 1}

%{?_with_kheaders: %global build_kheaders 1}

# Was passiert hier ???
%if %(if [ -z "$CC" ] ; then echo 0; else echo 1; fi)
%define kmake %make CC="$CC"
%else
%define kmake %make
%endif
# there are places where parallel make don't work
%define smake make


# kann weg?
## Aliases for amd64 builds (better make source links?)
# %define target_cpu    %(echo %{_target_cpu} | sed -e "s/amd64/x86_64/")
# %define target_arch    %(echo %{_arch} | sed -e "s/amd64/x86_64/")

Summary: The Linux kernel (the core of the Linux operating system).
#Name: %{kname}-%{mdkversion}
Name: %{kname}
#Version: %{rpmversion}
Version: %{mdkversion}
Release: %{rpmrelease}
License: GPL
Group: System/Kernel and hardware
ExclusiveArch: %{ix86} alpha ppc ia64 x86_64 amd64 sparc sparc64
ExclusiveOS: Linux
URL: http://www.kernel.org/

####################################################################
#
# Sources
#
Source0: ftp://ftp.kernel.org/pub/linux/kernel/v2.%{major}/linux-%{tar_version}.tar.bz2
Source1: ftp://ftp.kernel.org/pub/linux/kernel/v2.%{major}/linux-%{tar_version}.tar.bz2.sign
Source4: README.kernel-sources
Source5: README.MandrivaLinux
Source15: linux-mdkconfig.h
Source16: linux-merge-config.awk
Source100: linux-%{patches_ver}.tar.bz2
#Source101: belegen, falls eigene Patches nachtrglich dazukommen
####################################################################
#
# Patches

#
# Patch0 to Patch100 are for core kernel upgrades.
#

# Pre linus patch: ftp://ftp.kernel.org/pub/linux/kernel/v2.%{major}/testing

# PrePatches werden derzeit nicht genutzt
# In dem Verzeichnis liegen ausschlielich Release Candidates !!!

%if %use_patch
#Patch1: patch-%realversion-%use_patch.bz2
Patch2: linux-2.6.12-16kstacks.patch.tar.bz2
%endif

#END
####################################################################

# Defines for the things that are needed for all the kernels
%define requires1 modutils >= 2.4.25-2mdk
%define requires2 mkinitrd >= 3.4.43-10mdk
%define requires3 bootloader-utils >= 1.9
%define requires4 sysfsutils module-init-tools >= 0.9.15

%define kprovides kernel = %{realversion}, alsa

BuildRoot: %{_tmppath}/%{name}-%{realversion}-build
Provides: module-info, %kprovides
Autoreqprov: no
Requires: %requires1
Requires: %requires2
Requires: %requires3
Requires: %requires4
BuildRequires: gcc module-init-tools >= 0.9.15

%description
The kernel package contains the Linux kernel (vmlinuz), the core of your
Mandriva Linux operating system. The kernel handles the basic functions
of the operating system: memory allocation, process allocation, device
input and output, etc.

For instructions for update, see:
http://www.mandriva.com/security/kernelupdate


#%package -n %{kname}-source-2.%major
%package -n %{kname}-source
#Version: %{realversion}
Version: %{mdkversion}
#Release: %{realrelease}
Release: %{rpmrelease}
# durch umbenennen und weglassen von "2.6" nicht mehr erforderlich
#Provides: %{kname}-source
#Obsoletes: %{kname}-source
Requires: glibc-devel, ncurses-devel, make, gcc, perl
Summary: The source code for the Linux kernel.
Group: Development/Kernel
Autoreqprov: no

#%description -n %{kname}-source-2.%major
%description -n %{kname}-source
The kernel-source package contains the source code files for the Linux
kernel. These source files are needed to build most C programs, since
they depend on the constants defined in the source code. The source
files can also be used to build a custom kernel that is better tuned to
your particular hardware, if you are so inclined (and you know what you're
doing).

For instructions for update, see:
http://www.mandriva.com/security/kernelupdate


#
# kernel-doc: documentation for the Linux kernel
#
%package -n %{kname}-doc
#Version: %{version}
Version: %{mdkversion}
#Release: %{release}
Release: %{rpmrelease}
Summary: Various documentation bits found in the kernel source.
Group: Books/Computer books

%description -n %{kname}-doc
This package contains documentation files form the kernel source. Various
bits of information about the Linux kernel and the device drivers shipped
with it are documented in these files. You also might want install this
package if you need a reference to the options that can be passed to Linux
kernel modules at load time.

For instructions for update, see:
http://www.mandriva.com/security/kernelupdate

#
# End packages - here begins build stage
#
%prep
%setup -n %top_dir_name -c
%setup -n %top_dir_name -D -T -a100

# Hh? 
%define patches_dir ../%{patches_ver}/
cd %{patches_ver}
cd ..


# auskommentieren fr Vanilla-Kernel bis "%{patches_dir}/scripts/apply_patches"!!!
cd %src_dir
%if %use_patch
#%patch1 -p1
%patch2 -p1
%endif
#%{patches_dir}/scripts/apply_patches


# hier kommen die eigenen Patches mit Source ab 101 rein. Welche Syntax bentig ist, wei ich nicht genau.
# Put here patchlevel patches
# PATCH END
#
# Setup Begin
#
# Prepare all the variables for calling create configs

%if %build_debug
%define debug --debug
%else
%define debug --no-debug
%endif

#%if %build_minimal
#%define minimal --minimal
#%else
#%define minimal --no-minimal
#%endif

# hier wird die config fr u.a. fr "up" eingepatched
%{patches_dir}/scripts/create_configs %debug %minimal --user_cpu="%{target_cpu}"

# make sure the kernel has the sublevel we know it has...
LC_ALL=C perl -p -i -e "s/^SUBLEVEL.*/SUBLEVEL = %{sublevel}/" Makefile

# get rid of unwanted files
find . -name '*~' -o -name '*.orig' -o -name '*.append' |xargs rm -f

%if %build_kheaders

kheaders_dirs=`echo $PWD/include/{asm-*,linux,sound}`

pushd %build_dir
install -d kernel-headers/
cp -a $kheaders_dirs kernel-headers/
tar cf kernel-headers-%mdkversion.tar kernel-headers/
bzip2 -9f kernel-headers-%mdkversion.tar
rm -rf kernel-headers/
# build_kheaders
%endif


%build
# Common target directories
%define _kerneldir /usr/src/linux-%{KVERREL}
%define _bootdir /boot
#%ifarch ia64
#%define _efidir %{_bootdir}/efi/mandrake
#%endif
%define _modulesdir /lib/modules
%define _savedheaders ../../savedheaders/

# Directories definition needed for building
%define temp_root %{build_dir}/temp-root
%define temp_source %{temp_root}%{_kerneldir}
%define temp_boot %{temp_root}%{_bootdir}
%define temp_modules %{temp_root}%{_modulesdir}

PrepareKernel() {
    name=$1
    extension=$2
    echo "Prepare compilation of kernel $extension"
    %smake -s mrproper

    # We can't use only defconfig anymore because we have the autoconf patch,

    if [ -z "$name" ]; then
        config_name="defconfig"
    else
        config_name="defconfig-$name"
    fi
    cp arch/%{target_arch}/$config_name .config

    # make sure EXTRAVERSION says what we want it to say
    LC_ALL=C perl -p -i -e "s/^EXTRAVERSION =.*/EXTRAVERSION = -$extension/" Makefile
    %smake oldconfig
}

BuildKernel() {
    KernelVer=$1
    echo "Building kernel $KernelVer"

    %kmake all

    ## Start installing stuff
    install -d %{temp_boot}
    install -m 644 System.map %{temp_boot}/System.map-$KernelVer
    install -m 644 .config %{temp_boot}/config-$KernelVer

    %ifarch %{ix86}
    cp -f arch/i386/boot/bzImage %{temp_boot}/vmlinuz-$KernelVer
    %endif
    #%ifarch x86_64
    #cp -f arch/x86_64/boot/bzImage %{temp_boot}/vmlinuz-$KernelVer
    #%endif

    # modules
    install -d %{temp_modules}/$KernelVer
    %smake INSTALL_MOD_PATH=%{temp_root} KERNELRELEASE=$KernelVer modules_install
}

SaveHeaders() {
    flavour=$1
    flavour_name="`echo $flavour | sed 's/-/_/g'`"
%if %build_source
    HeadersRoot=%{temp_source}/savedheaders
    HeadersArch=$HeadersRoot/%{target_cpu}/$flavour
    echo "Saving hearders for $flavour %{target_cpu}"

    # deal with the kernel headers that are version specific
    install -d $HeadersArch
    install -m 644 include/linux/autoconf.h $HeadersArch/autoconf.h
    install -m 644 include/linux/version.h $HeadersArch/version.h
        echo "%{target_cpu} $flavour_name %{_savedheaders}%{target_cpu}/$flavour/" >> $HeadersRoot/list
%endif
}

CreateFiles() {
    kversion=$1
    output=../kernel_files.$kversion

    echo "%defattr(-,root,root)" > $output
    echo "%{_bootdir}/config-${kversion}" >> $output
    echo "%{_bootdir}/vmlinuz-${kversion}" >> $output
    echo "%{_bootdir}/System.map-${kversion}" >> $output
    echo "%dir %{_modulesdir}/${kversion}/" >> $output
    echo "%{_modulesdir}/${kversion}/kernel" >> $output
    echo "%{_modulesdir}/${kversion}/modules.*" >> $output
    echo "%doc README.kernel-sources" >> $output
    echo "%doc README.MandrivaLinux" >> $output
}

CreateKernel() {
    flavour=$1
    KernelVer=%{KVERREL}
    PrepareKernel "" %realrelease
    BuildKernel $KernelVer
    SaveHeaders $flavour
        CreateFiles $KernelVer
}


CreateKernelNoName() {
    arch=$1
    nprocs=$2
    memory=$3

        name=$arch-$nprocs-$memory
    extension="%realrelease-$name"

    KernelVer="%{KVERREL}-$arch-$nprocs-$memory"
    PrepareKernel $name $extension
    BuildKernel $KernelVer
    SaveHeaders $name
        CreateFiles $KernelVer
}

###
# DO it...
###

# Create a simulacro of %buildroot
rm -rf %{temp_root}
install -d %{temp_root}

#make sure we are in the directory
cd %src_dir

%if %build_up
CreateKernel up
%endif

# We don't make to repeat the depend code at the install phase
%if %build_source
PrepareKernel "" %{realrelease}custom
%smake -s prepare-all
%endif

###
### install
###
%install
install -m 644 %{SOURCE4}  .
install -m 644 %{SOURCE5}  .

cd %src_dir
# Directories definition needed for installing
%define target_source %{buildroot}/%{_kerneldir}
%define target_boot %{buildroot}%{_bootdir}
%define target_modules %{buildroot}%{_modulesdir}

# We want to be able to test several times the install part
rm -rf %{buildroot}
cp -a %{temp_root} %{buildroot}

# Create directories infastructure
%if %build_source
install -d %{target_source}

tar cf - . | tar xf - -C %{target_source}
chmod -R a+rX %{target_source}

# we remove all the source files that we don't ship

# first architecture files
for i in arm cris mips mips64 parisc ppc64 s390 s390x sh sh64 arm26 h8300 m68knommu v850 m32r frv; do
    rm -rf %{target_source}/arch/$i
    rm -rf %{target_source}/include/asm-$i
done
# ppc needs m68k headers
rm -rf %{target_source}/arch/m68k

# remove config split dir
rm -rf %{target_source}/include/config

# other misc files
rm -f %{target_source}/{.config.old,.config.cmd}

pushd %{target_source}/include/linux ; {
install -m 644 %{SOURCE15} rhconfig.h
rm -rf autoconf.h version.h
# Create autoconf.h file
echo '#include <linux/rhconfig.h>' > autoconf.h
sed 's,$,autoconf.h,' %{_savedheaders}list | awk -f %{SOURCE16} >> autoconf.h
# Create version.h
echo "#include <linux/rhconfig.h>" > version.h
loop_cnt=0


# was ist das fr Code?
# we will only support one kernel build
for i in BOOT up smp enterprise secure i686-up-4GB i686-up-1GB i686-smp-1GB i586-up-1GB; do
    if [ -d %{_savedheaders}%{target_cpu}/$i -a \
         -f %{_savedheaders}%{target_cpu}/$i/version.h ]; then
        name=`echo $i | sed 's/-/_/g'`
        if [ $loop_cnt = 0 ]; then
                  buf="#if defined(__module__$name)"
            else
                  buf="#elif defined(__module__$name)"
            fi
        echo "$buf" >> version.h
        grep UTS_RELEASE %{_savedheaders}%{target_cpu}/$i/version.h >> version.h
        loop_cnt=$[loop_cnt + 1]
    fi
done

#write last lines
if [ $loop_cnt -eq 0 ]; then
    echo "You need to build at least one kernel"
    exit 1;
fi
echo "#else" >> version.h
echo '#define UTS_RELEASE "'%{KVERREL}custom'"' >> version.h
echo "#endif" >> version.h

# Any of the version.h are ok, as they only differ in the first line
ls %{_savedheaders}%{target_cpu}/*/version.h | head -n 1 | xargs grep -v UTS_RELEASE >> version.h
rm -rf %{_savedheaders}
} ; popd
#endif %build_source
%endif

# gzipping modules
find %{target_modules} -name "*.ko" | xargs gzip -9

# We used to have a copy of PrepareKernel here
# Now, we make sure that the thing in the linux dir is what we want it to be

for i in %{target_modules}/*; do
  rm -f $i/build $i/source $i/modules.*
done

# sniff, if we gzipped all the modules, we change the stamp :(
# we really need the depmod -ae here

pushd %{target_modules}
for i in *; do
    /sbin/depmod-25 -u -ae -b %{buildroot} -r -F %{target_boot}/System.map-$i $i
    echo $?
done

for i in *; do
    pushd $i
    echo "Creating module.description for $i"
    modules=`find . -name "*.ko.gz"`
    echo $modules | xargs /sbin/modinfo-25 \
    | perl -lne 'print "$name\t$1" if $name && /^description:\s*(.*)/; $name = $1 if m!^filename:\s*(.*)\.k?o!; $name =~ s!.*/!!' > modules.description
    popd
done
popd

#export EXCLUDE_FROM_STRIP="vmlinuz-rs6k-%{KVERREL} vmlinuz-rs6k-%{KVERREL}smp vmlinuz-rs6k-%{KVERREL}enterprise vmlinuz-rs6k-%{KVERREL}BOOT"
export EXCLUDE_FROM_STRIP="vmlinuz-rs6k-%{KVERREL}"

###
### clean
###

%clean
rm -rf %{buildroot}
# We don't want to remove this, the whole reason of its existence is to be
# able to do several rpm --short-circuit -bi for testing install
# phase without repeating compilation phase
#rm -rf %{temp_root}

###
### scripts
###

%define options_preun -R
%define options_post -C

%preun
/sbin/installkernel %options_preun %{KVERREL}
exit 0

%post
/sbin/installkernel %options_post %{KVERREL}

%postun
/sbin/kernel_remove_initrd %{KVERREL}


#%post -n %{kname}-source-2.%major
%post -n %{kname}-source
cd /usr/src
rm -f linux
ln -snf linux-%{KVERREL} linux
/sbin/service kheader start 2>/dev/null >/dev/null || :
# we need to create /build only when there is a source tree.

for i in /lib/modules/%{KVERREL}*; do
    if [ -d $i ]; then
        ln -sf /usr/src/linux-%{KVERREL} $i/build
        ln -sf /usr/src/linux-%{KVERREL} $i/source
    fi
done

#%postun -n %{kname}-source-2.%major
%postun -n %{kname}-source
if [ -L /usr/src/linux ]; then
    if [ -L /usr/src/linux -a `ls -l /usr/src/linux 2>/dev/null| awk '{ print $11 }'` = "linux-%{KVERREL}" ]; then
    [ $1 = 0 ] && rm -f /usr/src/linux
    fi
fi
# we need to delete <modules>/build at unsinstall
for i in /lib/modules/%{KVERREL}*/{build,source}; do
    if [ -L $i ]; then
        rm -f $i
    fi
done
exit 0

###
### file lists
###

%if %build_up
%files -f kernel_files.%{KVERREL}
%endif

%if %build_source
#%files -n %{kname}-source-2.%{major}
%files -n %{kname}-source
%defattr(-,root,root)
%dir %{_kerneldir}
%dir %{_kerneldir}/arch
%dir %{_kerneldir}/include
%{_kerneldir}/.config
%{_kerneldir}/COPYING
%{_kerneldir}/CREDITS
%{_kerneldir}/Documentation
%{_kerneldir}/MAINTAINERS
%{_kerneldir}/Makefile
%{_kerneldir}/README
%{_kerneldir}/REPORTING-BUGS
%{_kerneldir}/arch/alpha
%{_kerneldir}/arch/i386
%{_kerneldir}/arch/ia64
%{_kerneldir}/arch/ppc
%{_kerneldir}/arch/sparc
%{_kerneldir}/arch/sparc64
%{_kerneldir}/arch/x86_64
%{_kerneldir}/arch/um
%{_kerneldir}/crypto
%{_kerneldir}/drivers
%{_kerneldir}/fs
%{_kerneldir}/init
%{_kerneldir}/ipc
%{_kerneldir}/kernel
%{_kerneldir}/lib
%{_kerneldir}/mm
%{_kerneldir}/net
%{_kerneldir}/security
%{_kerneldir}/scripts
%{_kerneldir}/sound
%{_kerneldir}/usr
%{_kerneldir}/include/acpi
%{_kerneldir}/include/asm
%{_kerneldir}/include/asm-alpha
%{_kerneldir}/include/asm-generic
%{_kerneldir}/include/asm-i386
%{_kerneldir}/include/asm-ia64
# This is needed by ppc
%{_kerneldir}/include/asm-m68k
%{_kerneldir}/include/asm-ppc
%{_kerneldir}/include/asm-sparc
%{_kerneldir}/include/asm-sparc64
%{_kerneldir}/include/asm-x86_64
%{_kerneldir}/include/asm-um
%{_kerneldir}/include/linux
%{_kerneldir}/include/math-emu
%{_kerneldir}/include/net
%{_kerneldir}/include/pcmcia
%{_kerneldir}/include/scsi
%{_kerneldir}/include/sound
%{_kerneldir}/include/video
%{_kerneldir}/include/media
%{_kerneldir}/include/mtd
# auskommeniteren fr vanilla
# %{_kerneldir}/3rdparty
# auskommeniteren fr vanilla
# %{_kerneldir}/kdb
# auskommeniteren fr vanilla
# %{_kerneldir}/rsbac
# auskommentieren fr vanilla
# %{_kerneldir}/include/rsbac



%{_kerneldir}/include/rxrpc
%doc README.kernel-sources
%doc README.MandrivaLinux
#endif %build_source
%endif

%if %build_doc
%files -n %{kname}-doc
%defattr(-,root,root)
%doc linux-%{tar_version}/Documentation/*
%endif

%changelog
* Mon Aug 01 2005 Doktor5000 <rpm@mandrivauser.de> 2.6.12-4-205.doc
- final build
- changed patch-processing
- AndyRTR did the whole work actually
- renewed SPEC & sources, now based on vanilla 2.6.12-4 

* Sun Jul 03 2005 AndyRTR <andreas.radke@freenet.de> 2.6.12-3rtr
- rewrite for MandrivaUser.de vanilla kernel
- clean up
- removed non supported arch_types
- removed stripped source
- only build on kernel "up"
- added %second_sublevel
- changed naming of package versions
- rebuild for Mandriva 2005LE

* Thu Jun 23 2005 Flvio Bruno Leitner <flavio@mandriva.com> 2.6.12-3mdk
- new kernel version: 2.6.12.1
- rollback some of removed patches in 2.6.12-1mdk.

* Wed Jun 22 2005 Flvio Bruno Leitner <flavio@mandriva.com> 2.6.12-2mdk
- added drbd 0.7.11

* Wed Jun 22 2005 Flvio Bruno Leitner <flavio@mandriva.com> 2.6.12-1mdk
- new kernel version: 2.6.12
- updated bootsplash: 3.1.6
- enabled config on /proc. (/proc/config.gz)
- enabled cpufreq conservative module.
- removed ipmi smb support until be fixed for 2.6.12.
- enabled new sensors modules.
- renamed MandrakeSoft to Mandriva. (README.Mandriva too)
- fixed/improved some descriptions.
- don't use tarball for patches and scripts. (svn repos)
- added new patches:
  o MD27_tivatv-agp.patch (agp_copy_info changed)
  o MD56_pci_name-renamed.patch (s/pci->slot_name/pci_name()/)
  o MD55_i2c-client-unused-id.patch (drop unused i2c_client->id)
  o MD54_3rdpart-scsi-legacy.patch (rollback some SCSI defines)
  o JX02_reparent_public.patch (XBOX needs reparent_to_init)
  o MD53_3rdpart-removed-defined-func.patch (gcc4 fix)
  o DV32_via_mach64_drm_fixes.patch (minor field moved)
  o RS13_rsbac-2.6.12.patch (RSBAC needs task_capability_lock)
- removed already applied patches (about 55 patches)
